let selectedOption;
let answerPoints = 0;
let nextButtonClicked = 0;
let clickedFlag = false;

let modalDiv = document.createElement("div");
let modalLoaded = false;
let nextBtn = document.getElementById("next-button");

// Triggered when user click on any option
const selectOption = (value) => {
  // Uncheck option if checked
  if (selectedOption === value) {
    value.checked = false;
    selectedOption = null; // Setting selected option to null
  } else {
    selectedOption = value;
    clickedFlag = true;
  }
};

// Triggered when next button on quiz page gets pressed
const nextQuiz = () => {
  nextButtonClicked += 1; // Keeping count of next button clicked

  // Switch based on option selected by user
  switch (selectedOption) {
    // For question 1
    case "Everyday":
      answerPoints = 3; // Setting answer points based on option selected
      break;

    case "Once a Week":
      answerPoints = 4; // Setting answer points based on option selected
      break;

    case "Occasionally":
      answerPoints = 2; // Setting answer points based on option selected
      break;

    case "Never, I just started smoking":
      answerPoints = 1; // Setting answer points based on option selected
      break;

    // For question 2
    case "Zero":
      answerPoints += 4;
      break;

    case "One or two":
      answerPoints += 3;
      break;

    case "I have a box of them":
      answerPoints += 2;
      break;

    case "I have more than I can count":
      answerPoints += 1;
      break;

    // For question 3
    case "No, I havent even considered it":
      answerPoints += 4;
      break;

    case "No, but I have been thinking about purchasing one":
      answerPoints += 2;
      break;

    case "Yes, I do have a very small one":
      answerPoints += 3;
      break;

    case "Yes, my humidor is almost a whole room in my house":
      answerPoints += 1;
      break;

    // For question 4
    case "Just a few dollars so far":
      answerPoints += 2;
      break;

    case "Less than $50.00":
      answerPoints += 4;
      break;

    case "Somewhere between $50 - $200 per month":
      answerPoints += 3;
      break;

    case "A LOT":
      answerPoints += 1;
      break;

    // For question 5
    case "Light aka “Mellow” Bodied":
      answerPoints += 2;
      break;

    case "Medium-Bodied":
      answerPoints += 3;
      break;

    case "Full-Bodied":
      answerPoints += 4;
      break;

    case "I don’t know what strength I would prefer":
      answerPoints += 1;
      break;

    // For question 6
    case "Earthy or Plant-Like Flavors":
      answerPoints += 3;
      break;

    case "Herbal or Spicy Flavors":
      answerPoints += 4;
      break;

    case "Fruity or Sweet Flavors":
      answerPoints += 1;
      break;

    case "Roasted or Toasted Flavors":
      answerPoints += 2;
      break;

    // For question 7
    case "Nope, it gets me more fired up":
      answerPoints += 4;
      break;

    case "I guess so. I definitely enjoy the feeling":
      answerPoints += 2;
      break;

    case "Yes, smoking a good cigar helps me maintain my cool":
      answerPoints += 1;
      break;

    case "It might. I get so worked up that it could be helpful":
      answerPoints += 3;
      break;

    // For question 8
    case "I’ve never done that before. Is it good":
      answerPoints += 1;
      break;

    case "I do that occasionally, but only if the cigar I’m smoking isn’t very good":
      answerPoints += 4;
      break;

    case "ALL the time It tastes AMAZING":
      answerPoints += 3;
      break;

    case "No, I would never ruin a cigar by doing that":
      answerPoints += 2;
      break;

    // For question 9
    case "A Classic Steakhouse":
      answerPoints += 4;
      break;

    case "A French Bistro":
      answerPoints += 1;
      break;

    case "A Gastropub":
      answerPoints += 3;
      break;

    case "A Small, Local, Family Diner that serves breakfast all day":
      answerPoints += 2;
      break;

    // For question 10
    case "None, I am a brand-new cigar smoker":
      answerPoints += 2;
      break;

    case "Just one or two":
      answerPoints += 4;
      break;

    case "I have a revolving rotation of a handful of brands I like":
      answerPoints += 3;
      break;

    case "A lot. I can’t keep track of them all":
      answerPoints += 1;
      break;
  }
  clickedFlag = false;

  if (nextButtonClicked === 10) {
    showMyModal();
    if (answerPoints >= 1 && answerPoints <= 19) {
      document.getElementById("cigar-title").innerHTML = "La Palina Goldie";
    }
    if (answerPoints >= 20 && answerPoints <= 29) {
      document.getElementById("cigar-title").innerHTML =
        "La Palina Connecticut";
    }
    if (answerPoints >= 30 && answerPoints <= 39) {
      document.getElementById("cigar-title").innerHTML =
        "La Palina Bronze Label";
    }
    if (answerPoints >= 40) {
      document.getElementById("cigar-title").innerHTML =
        "La Palina Silver Label";
    }
  }
};

const loadMyModal = () => {
  if (modalLoaded) {
    return;
  }

  modalDiv.innerHTML = `
  <div id="myModal" class="modal" data-keyboard = "false" data-backdrop = "static" tabindex="-1">
    <div class="modal-dialog">
      <div class="modal-content">
        <div class="modal-header">
          <h5 class="modal-title">Thank you for taking our quiz</h5>
          <button type="button" class="btn-close" data-bs-dismiss="modal" aria-label="Close"></button>
        </div>
        <div class="modal-body">
            <label>
              <input type="text" class="form-control" name="email" id="email" placeholder="EMAIL:">
            </label>
          <br />
        </div>
        <div class="modal-footer">
          <button type="button" class="btn-secondary" data-bs-dismiss="modal">Close</button>
          <button type="button" class="btn-primary" data-dismiss="modal" onclick="sendData()">Submit</button>
        </div>
      </div>
    </div>
  </div>`;

  document.body.appendChild(modalDiv);
  modalLoaded = true;
};

const showMyModal = () => {
  if (!modalLoaded) {
    loadMyModal();
  }
  $("#myModal").modal("show");
};

const sendData = async () => {
  let emailRegex =
    /^[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+@[a-zA-Z0-9-]+(?:\.[a-zA-Z0-9-]+)*$/;
  let email = $("#email").val();
  if (_.isEmpty(email)) {
    alert("<p> Please enter email address.</p>");
  } else {
    if (email.match(emailRegex)) {
      let requestObject = { email };
      await fetch;
      fetch("https://la-palina.herokuapp.com/api/email", {
        method: "POST",
        headers: {
          "Content-Type": "application/json",
        },
        body: JSON.stringify(requestObject),
      })
        .then((response) => response.json())
        .then((data) => {
          console.log("Success:", data);
        })
        .catch((error) => {
          console.error("Error:", error);
        });
    } else {
      alert("<p> Please enter a valid email address.</p>");
    }
  }
};
