let detailsDiv = document.getElementById("address1");
let searchBtn = document.getElementById("search-button");

let locations = [];

searchBtn.addEventListener("click", () => {
  searchAPIData();
});

// Initialize and add the map
window.initMap = function () {
  const defaultLocation = { lat: 41.87773199999999, lng: -87.647595 };
  // The map, centered at Uluru
  const map = new google.maps.Map(document.getElementById("map"), {
    zoom: 4,
    center: defaultLocation,
  });

  setTimeout(() => {
    setMarker();
  }, 2000);
};

const setMarker = async () => {
  const map = new google.maps.Map(document.getElementById("map"), {
    zoom: 5,
    center: { lat: 37.09024, lng: -95.712891 },
  });

  const infoWindow = new google.maps.InfoWindow({
    content: "",
    disableAutoPan: true,
  });
  // Create an array of alphabetical characters used to label the markers.
  const labels = "ABCDEFGHIJKLMNOPQRSTUVWXYZ";
  // Add some markers to the map.
  const markers = locations.map((position, i) => {
    const label = labels[i % labels.length];
    const marker = new google.maps.Marker({
      position,
      label,
    });

    // markers can only be keyboard focusable when they have click listeners
    // open info window when marker is clicked
    marker.addListener("click", () => {
      infoWindow.setContent(label);
      infoWindow.open(map, marker);
    });
    return marker;
  });

  // Add a marker clusterer to manage the markers.
  const markerCluster = new markerClusterer.MarkerClusterer({ map, markers });
};

const searchAPIData = async () => {
  let searchLocation = document.getElementById("staticEmail2");
  if (
    searchLocation == "" ||
    searchLocation == undefined ||
    searchLocation == null
  ) {
    alert("popup");
  } else {
    let searchTerm = searchLocation.value.trim();
    let detailsDiv = document.getElementById("address1");
    await fetch(
      `https://lapalina.acumatica.com/entity/Default/17.200.001/CustomerLocation?$expand=LocationContact/Address&$custom=LocationCurrent.UsrRetFeedWeb&$filter=LocationContact/Address/City eq '${searchTerm}'`,
      {
        method: "GET",
        headers: {
          "Content-Type": "application/json",
        },
      }
    ).then((response) => {
      response.map((element) => {
        // setMarker(
        //   element.Address,
        //   null,
        //   element.City,
        //   element.State,
        //   element.Postal
        // );

        locations.map((locationItem) => {
          locationItem.lat = element.Latitude;
          locationItem.lng = element.Longitude;
        });

        setMarker();

        detailsDiv.innerHTML = `
          <h5>${element.Name}</h5>
          ${element.FullAddress} <br />
          <span><em>1.58 miles</em></span>
          <br />
          <a href="#">Directions</a>
        `;
      });
    });
  }
};

window.onload = async () => {
  const authObject = {
    client_id: "832F2B13-13AB-5B42-1A3B-3254192193A5@La Palina",
    client_secret: "yyvY_1_hWFqb8Qk7hgs7Mw",
    grant_type: "password",
    scope: "api",
    username: "website",
    password: "r8qc_eekMcDT&G7k",
  };
  await fetch(
    "https://lapalina.acumatica.com/entity/Default/17.200.001/identity/connect/token",
    {
      method: "POST",
      body: JSON.stringify(authObject),
      mode: "cors",
      headers: {
        "Content-Type": "application/json",
      },
    }
  ).then((response) => console.log("API response: ", response));
};
